import request from "@/utils/request";

export function LIST(params) {
  return request({
    url: "/pu/contract/list",
    method: "GET",
    params: params,
  });
}

export function ADD(data) {
  return request({
    url: "/pu/contract/add",
    method: "POST",
    data: data,
  });
}

export function EXPORT(data) {
  return request({
    url: "/pu/contract/export",
    method: "POST",
    data: data,
  });
}

export function EDIT(data) {
  return request({
    url: "/pu/contract/edit",
    method: "PUT",
    data: data,
  });
}

export function REMOVE(data) {
  return request({
    url: `/pu/contract/${data}`,
    method: "DELETE",
  });
}

export function ITEM(data) {
  return request({
    url: `/pu/contract/${data}`,
    method: "GET",
  });
}

export function CODE() {
  return request({
    url: "/pu/contract/generateNo",
    method: "GET",
  });
}

export function TABLELIST(params, name) {
  let url = "";
  if (name === "contractItemList") url = "/pu/contract/item/list";
  if (name === "contractClauseList") url = "/pu/contract/clause/list";
  if (name === "contractExpenseList") url = "/pu/contract/expense/list";
  if (name === "contractAgreementList") url = "/pu/contract/agreement/list";
  if (name === "contractApplyOrgList") url = "/pu/contract/org/list";
  return request({
    url: url,
    method: "GET",
    params: params,
  });
}

export function TABLEROMOVE(data, name) {
  let url = "";
  if (name === "contractItemList") url = "/pu/contract/item";
  if (name === "contractClauseList") url = "/pu/contract/clause";
  if (name === "contractExpenseList") url = "/pu/contract/expense";
  if (name === "contractAgreementList") url = "/pu/contract/agreement";
  if (name === "contractApplyOrgList") url = "/pu/contract/org";
  return request({
    url: `${url}/${data}`,
    method: "DELETE",
  });
}
