import { Columns, TabColumns } from "../add/column";
import { initColumns, initParams } from "@/utils/init";


export const editColumns = initColumns(Columns);

export const editTabColumns = TabColumns.map((element) => ({
  ...element,
  tableColumns: initColumns(element.tableColumns),
}));

export const SelectColumns = editColumns.filter(column => column.inputType === 'Select')

editTabColumns.forEach(column => {

  SelectColumns.push(...column.tableColumns.filter(cColumn => cColumn.inputType === 'Select'))

});



// 禁用项
export const forbidden = (isEdit) => {

  console.log(isEdit, 'isEdit');
  if (isEdit) {
    console.log('编辑');
    // 编辑
    editColumns.forEach(item => {
      item.disabled = false;
      item.readonly = false;
    })

    editTabColumns.forEach(item => {

      item.tableColumns.forEach(t => {
        t.disabled = false;
        t.readonly = false;
      })
    })
  } else {
    console.log('修订');
    // 修订
    editColumns.forEach(item => {

      if (item.key == 'buyerName' || item.key == 'puDeptName' || item.key == 'deductionMoney' ||
        item.key == 'supplierContactsName' || item.key == 'agentName' || item.key == 'isInvoice' ||
        item.key == 'rebateMoney') {
        item.disabled = false;
        item.readonly = false;
      } else {
        item.disabled = true;
        item.readonly = true;
      }
    })

    editTabColumns.forEach(item => {

      item.tableColumns.forEach(t => {

        if (t.key == 'unit' || t.key == 'qty' ||
          t.key == 'place' || t.key == 'arrivalDatePlan' || t.key == 'storageCondition' ||
          t.key == 'carriageCondition' || t.key == 'customerName' || t.key == 'isBatchLock' ||
          t.key == 'isReplenishment' || t.key == 'originalQty' || t.key == 'originalMoney'
        ) {

          t.disabled = false;
          t.readonly = false;
        } else {
          t.disabled = true;
          t.readonly = true;
        }
      })
    })

  }

  return { editColumns, editTabColumns }

}
